      //--------------------------------------------------------------------
      // Utility routines for reading data from a dBase format Files
      // from ILE RPG.
      //--------------------------------------------------------------------

     h nomain BNDDIR('QC2LE')
     h option(*nodebugio:*srcstmt:*seclvl)

      /copy qrpglesrc,DBASEFPRC
      /copy qrpglesrc,IFSIO_H
      /copy qrpglesrc,ERRNO_H

     dconvertASCIItoEBCDIC...
     d                 PR                  ExtPgm('QDCXLATE')
     d   Length                       5P 0 const
     d   Data                     65535A   options(*varsize)
     d   Table                       10A   const

      /define ERRNO_LOAD_PROCEDURE
      /copy qrpglesrc,ERRNO_H

      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      // closeDBaseFile: Close a dBase (.dbf) format file
      //
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     pcloseDBaseFile...
     p                 b                   EXPORT
     dcloseDBaseFile...
     d                 pi
     d  prmHeaderPtr                   *   CONST

     d  DSHeader       ds                  likeds(dbfHeader) based(ptrHeader)
     d  wkByte         s              1a
     d  wkData         s           5000a
     d  wkFileDscr     s             10i 0
     d  wkChar         s              1a

      /free
         ptrHeader =  prmHeaderPtr;

         if ptrHeader <> *Null;
            wkFileDscr = DSHeader.FileDescriptor;
            callp close(wkFileDscr);

            ptrHeader = *null;
         endif;

         return;
      /end-free

     pcloseDBaseFile...
     p                 e

      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      // openDBaseFile:    Open a dBase (.dbf) format file
      //
      //    prmStreamFile: Stream File for to the dBase file
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     popenDBaseFile...
     p                 b                   EXPORT
     dopenDBaseFile...
     d                 pi              *
     d prmStreamFile                200A   CONST

     d wkFileDscr      s             10i 0
     d DSHeader        ds                  likeds(dbfHeader) static
     d wkByte          s              1a
     d wkChar          s              1a
     d wkData          s           5000a   varying
     d wkLength        s             10i 0
     d wkRcdsFound     s              1N
     d wkHdrEndFlg     s              1N
     d wkHdrVldFlg     s              1N
     d ptrHeader       s               *
     d wkAddrLen       s             10i 0
     d wkIndex         s              5  0
     d wkFieldIx       s              5  0
     d wkFieldOffset   s             10i 0
     d wkHdrBytes      s              5  0
     d wkDataLen       s             10i 0

     d wkHexToDec      ds                  qualified
     d   IntDec                       5i 0 inz(0)
     d   Char                         1a   overlay(IntDec:2)

     ddateDS           ds                  qualified
     d year                    1      3  0
     d month                   4      5  0
     d day                     6      7  0

     d wkFieldDS       ds                  qualified
     d   name                  1     11a
     d   type                 12     12a
     d   length               17     17a
     d   dec                  18     18a

     d wkErrStr        s             80a
     d wkErrNo         s             10i 0
     d wkConvertedDta  s          65535a

      /free
          ptrHeader = %alloc(%size(DSHeader));

          wkFileDscr = open( %trim(prmStreamFIle): O_RDONLY);

          ptrHeader = %addr(DSHeader);
          wkRcdsFound = *on;
          wkHdrEndFlg = *off;
          dow wkRcdsFound = *on;
            clear wkErrNo;
            clear wkErrStr;
            wkLength = read( wkFileDscr: %addr(wkByte):1);
            if wkLength = 0;
               wkErrNo = errno();
               wkErrStr = %str(strerror(wkErrNo));
               wkRcdsFound = *off;
            endif;
            dow (wkLength <> 0);
               if wkByte = x'0d';
                  if wkData <> '';
                     wkData = %trim(wkData) + wkByte;
                  endif;
                  wkHdrEndFlg = *on;
                  leave;
               else;
                  wkData = %trim(wkData) + wkByte;
               endif;
               wkLength = read(wkFileDscr: %addr(wkByte): 1);
            enddo;
            if wkHdrEndFlg = *on;
               leave;
            endif;
         enddo;

         if wkHdrEndFlg = *on and wkRcdsFound = *on;
            exsr @readHdrData;
            if wkHdrVldFlg = *on;
               DSHEader.FileDescriptor = wkFileDscr;
               DSHeader.FieldCount = wkFieldIx ;
            else;
               ptrHeader = *null;
            endif;
         else;
            ptrHeader = *null;
         endif;

         return ptrHeader;

        //----------------------------------------------------------------
        // @readHdrData; Read information from the dbf header
        //
        //----------------------------------------------------------------
         begsr @readHdrData;

             wkHdrVldFlg = *on;

            wkHexToDec.Char = %subst(wkData:1:1);
            DSHeader.version = wkHexToDec.IntDec;

            dateDS = '0000000';
            wkHexToDec.Char = %subst(wkData:2:1);
            dateDS.year = wkHexToDec.IntDec;
            wkHexToDec.Char = %subst(wkData:3:1);
            dateDS.month = wkHexToDec.IntDec;
            wkHexToDec.Char = %subst(wkData:4:1);
            dateDS.day = wkHexToDec.IntDec;
            monitor;
               DSHeader.lastUpdated = %date(dateDS: *CYMD0);
            on-error;
               DSHeader.lastUpdated = *loval;
               wkErrNo = errno();
               wkErrStr = %str(strerror(wkErrNo));
            dump(a);
            endmon;

            DSHeader.recordCount = 0;
            for wkIndex = 3 downto 0;
               wkHexToDec.Char = %subst(wkData: 5+wkIndex: 1);
               DSHeader.recordCount += (wkHexToDec.IntDec * (256**wkIndex));
            endfor;

            wkHdrBytes = 0;
            for wkIndex = 1 downto 0;
               wkHexToDec.Char = %subst(wkData: 9+wkIndex: 1);
               wkHdrBytes += (wkHexToDec.IntDec * (256**wkIndex));
            endfor;

            DSHeader.bytesPerRecord = 0;
            for wkIndex = 1 downto 0;
               wkHexToDec.Char = %subst(wkData:11+wkIndex:1);
               DSHeader.bytesPerRecord += (wkHexToDec.IntDec * (256**wkIndex));
            endfor;

            wkFieldIx = 0;
            wkFieldOffset = 1;
            for wkIndex = 33 to wkHdrBytes-1 by 32;
               wkFieldIx += 1;
               wkFieldDs = %subst(wkData: wkIndex: 32);
               wkConvertedDta = wkFieldDS.Name;
               convertASCIItoEBCDIC(11: wkConvertedDta : 'QTCPEBC');
               wkConvertedDta = %xlate(x'00': x'40': wkConvertedDta);
               DSHeader.Fields(wkFieldIx).Name = wkConvertedDta;
               wkConvertedDta = wkFieldDS.Type;
               convertASCIItoEBCDIC(1: wkConvertedDta: 'QTCPEBC');
               DSHeader.Fields(wkFieldIx).Type = wkConvertedDta;
               wkHexToDec.Char = wkFieldDS.Length;
               DSHeader.Fields(wkFieldIx).Length = wkHexToDec.IntDec;
               DSHeader.Fields(wkFieldIx).Offset = wkFieldOffset;
               wkHexToDec.Char = wkFieldDS.Dec;
               DSHeader.Fields(wkFieldIx).Decimals = wkHexToDec.IntDec;
               wkFieldOffset += DSHeader.Fields(wkFieldIx).Length;
            endfor;
         endsr;

      /end-free
     popenDBaseFile...
     P                 E

      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      // readDBaseFile: Read the next record from a dBase File
      //
      //   ptrHeader: Pointer The dBase File header data structure
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     preadDBaseFile...
     p                 b                   EXPORT

     dreadDBaseFile...
     d                 pi              *
     d ptrHeader                       *   CONST

     d DSHeader        ds                  likeds(dbfHeader) based(ptrHeader)
     d wkByte          s              1a
     d wkData          s           5000a
     d wkFileDscr      s             10i 0
     d wkLength        s             10i 0
     d wkReturnData    s          65535a   static
     d wkHdrPtr        s               *
     d wkConvertedDta  s          65535a

     d ptrRecord       s               *

      /free

         wkHdrPtr = ptrHeader;

         if wkHdrPtr = *NULL;
            return *NULL;
         endif;

         if DSHeader.bytesPerRecord = 0;
            return *NULL;
         endif;

         ptrRecord = %alloc(DSHeader.bytesPerRecord);
         wkFileDscr = DSHEader.FileDescriptor;

         wkData = '';
         wkByte = '';
         wkLength = read( wkFileDscr: %addr(wkData): DSHeader.bytesPerRecord);

         if wkLength <> 0;
            wkReturnData = %subst(wkData: 2: DSHeader.bytesPerRecord);
            convertASCIItoEBCDIC( DSHeader.bytesPerRecord
                               : wkReturnData: 'QTCPEBC');
            ptrRecord = %addr(wkReturnData);
         endif;

         return ptrRecord;

      /end-free
     preadDBaseFile...
     p                 e

      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      // getDBaseField: Retreive the specified field from the defined
      //                record/file based on the column number
      // ptrHeader      Pointer to the header data structure for the file
      // ptrRecord      The pointer to the record containing the data
      // prmFieldNbr    The numeric ordinal position of the field
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     pgetDBaseField...
     p                 b                   EXPORT

     dgetDBaseField...
     d                 pi                  likeds(fieldData)
     d ptrFile                         *   CONST
     d ptrRecord                       *   CONST
     d prmFieldNbr                    3  0 CONST

     d DSHeader        ds                  likeds(dbfHeader) based(wkHdrPtr)
     d wkRecord        s          65535a   based(wkRecordPtr)
     d wkHdrPtr        s               *
     d wkRecordPtr     s               *
     d wkDataVal       s          65535a
     d wkFieldCol      s              5  0

      /free

         clear fieldData;

         if ptrFile= *NULL or ptrRecord = *NULL;
            fieldData.String = '*ERROR';
            fieldData.Type = '*';
            return fieldData;
         endif;

         wkHdrPtr = ptrFile;
         wkRecordPtr = ptrRecord;

         if prmFieldNbr > DSHeader.fieldCount;
            fieldData.String = '*ERROR';
            fieldData.Type = '*';
            return fieldData;
         endif;

         wkFieldCol = prmFieldNbr;

         wkDataVal = %subst( wkRecord: DSHeader.fields(wkFieldCol).offset
                            : DSHeader.fields(wkFieldCol).length);
         fieldData.String = wkDataVal;

         fieldData.Type = DSHeader.fields(wkFieldCol).type;
         select;
            when fieldData.Type = 'D';
               monitor;
                  fieldData.Date = %date(wkDataVal);
               on-error;
                  fieldData.Date = *loval;
               endmon;
            when fieldData.Type = 'F' or fieldData.Type = 'N' or
                    fieldData.Type = 'S';
               if wkDataVal = '';
                  fieldData.Number = 0;
               else;
                  fieldData.Number = %dec(wkDataVal: 31: 9);
               endif;
         endsl;

         return fieldData;
      /end-free
     pgetDBaseField...
     p                 e
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      // getDBaseFieldByName: Retreive the specified field from the a
      //                      dBase file/record based on the field name
      // ptrFile        The pointer to the file header data structure
      // ptrRecord      The pointer to the record containing the data
      // prmFieldName   The name of the field.
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     pgetDBaseFieldByName...
     p                 b                   EXPORT

     dgetDBaseFieldByName...
     d                 pi                  likeds(fieldData)
     d ptrFile                         *   CONST
     d ptrRecord                       *   CONST
     d prmFieldName                  11a   CONST

     d DSHeader        ds                  likeds(dbfHeader) based(wkHdrPtr)
     d wkRecord        s          65535a   based(wkRecordPtr)
     d wkHdrPtr        s               *
     d wkRecordPtr     s               *
     d wkDataVal       s          65535a
     d wkFieldCol      s              5  0
     d wkIndex         s              5  0
     d wkFieldFound    s              1N

      /free

         clear fieldData;

         if ptrFile = *NULL or ptrRecord = *NULL;
            fieldData.String = '*ERROR';
            fieldData.Type = '*';
            return fieldData;
         endif;

         wkHdrPtr = ptrFile;
         wkRecordPtr = ptrRecord;

         wkFieldFound = *off;
         for wkIndex = 1 to DSHeader.fieldCount;
            if DSHeader.Fields(wkIndex).name = prmFieldName;
               wkFieldFound = *on;
               wkFieldCol = wkIndex;
               leave;
            endif;
         endfor;

         if wkFieldFound = *off;
            fieldData.String = '*ERROR';
            fieldData.Type = '*';
            return fieldData;
         endif;

         wkDataVal = %subst( wkRecord: DSHeader.fields(wkFieldCol).offset
                            : DSHeader.fields(wkFieldCol).length);
         fieldData.String = wkDataVal;
         fieldData.Type = DSHeader.fields(wkFieldCol).type;

         select;
            when fieldData.Type = 'D';
               monitor;
                  fieldData.Date = %date(wkDataVal);
               on-error;
               endmon;
            when fieldData.Type = 'F' or fieldData.Type = 'N' or
                     fieldData.Type = 'S';
               if wkDataVal = '';
                  fieldData.Number = 0;
               else;
                  monitor;
                     fieldData.Number = %dec(wkDataVal: 31: 9);
                  on-error;
                  endmon;
               endif;
         endsl;

         return fieldData;
      /end-free
     pgetDBaseFieldByName...
     p                 e

